function y = NLMeans(x,B,D,h);

[M N] = size(x);
T = 40;   % elabora solo la parte centrale  (2T+1)*(2T+1)     
kernel = fspecial('gaussian',2*B+1,1.7);

y = x;
for m=M/2-T:M/2+T,
  for n=N/2-T:N/2+T,
    W = zeros(2*D+1,2*D+1);
    targetblock = x(m-B:m+B,n-B:n+B);
    for md=m-D:m+D,
      for nd=n-D:n+D,    
        refblock = x(md-B:md+B,nd-B:nd+B);
        E2(md-(m-D)+1,nd-(n-D)+1) = sum(sum(kernel.*(targetblock-refblock).^2));
      end;
    end;
    W  = exp(-E2/(h^2));
    W(D+1,D+1) = 0;              % peso del pixel centrale  posto
    W(D+1,D+1) = max(W(:));      % pari al massimo dei pesi stimati
    W = W/sum(W(:));
    WY = W.*x(m-D:m+D,n-D:n+D);
    y(m,n) = sum(WY(:));
  end;
end;